export interface Newable<T> {
    new (...args: any[]): T;
}
export interface Abstract<T> {
    prototype: T;
}
export declare type ServiceIdentifier<T> = (string | symbol | Newable<T> | Abstract<T>);
export declare function InterfaceSymbol<T extends Object>(): symbol;
export declare class Container {
    private _map;
    get<T>(key: ServiceIdentifier<T> | ServiceIdentifier<T>[]): any;
    bind<T>(serviceIdentifier: ServiceIdentifier<T>, constructor: Newable<T>, params?: any[]): void;
    bindToConstant<T>(serviceIdentifier: ServiceIdentifier<T>, constant: any): void;
    resolve<T>(service: Newable<T>, params?: any[]): T;
}
